package ru.dbotthepony.mc.otm.client.render

import net.minecraft.client.renderer.texture.TextureAtlas
import net.minecraft.client.renderer.texture.TextureAtlasSprite
import net.minecraft.client.renderer.texture.TextureManager
import net.minecraft.client.resources.TextureAtlasHolder
import net.minecraft.resources.ResourceLocation
import net.minecraft.server.packs.resources.ReloadableResourceManager
import net.minecraft.server.packs.resources.ResourceManager
import net.minecraft.util.profiling.ProfilerFiller
import net.minecraftforge.client.event.RegisterClientReloadListenersEvent
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.client.minecraft
import ru.dbotthepony.mc.otm.client.onceClient
import ru.dbotthepony.mc.otm.registry.WriteOnce
import java.util.stream.Stream
import kotlin.properties.Delegates

var isWidgetAtlasAvailable: Boolean = false
	private set

class WidgetAtlasHolder private constructor(manager: TextureManager) : TextureAtlasHolder(manager, LOCATION, "gui") {
	var changeset = 0
		private set

	private var queued = false
	private var once = false

	private var resourceManager by Delegates.notNull<ResourceManager>()
	private var profileManager by Delegates.notNull<ProfilerFiller>()

	override fun prepare(p_118891_: ResourceManager, p_118892_: ProfilerFiller): TextureAtlas.Preparations {
		once = true
		resourceManager = p_118891_
		profileManager = p_118892_
		return super.prepare(p_118891_, p_118892_)
	}

	public override fun getSprite(p_118902_: ResourceLocation): TextureAtlasSprite {
		if (!once) {
			throw IllegalStateException("Trying to get sprite too early")
		}

		return super.getSprite(p_118902_)
	}

	fun queueRebuild() {
		if (!queued && once) {
			queued = true

			onceClient(20) {
				queued = false
				apply(prepare(resourceManager, profileManager), resourceManager, profileManager)
			}
		}
	}

	override fun getResourcesToLoad(): Stream<ResourceLocation> {
		changeset++
		return AtlasSkinElement.keys
	}

	companion object {
		@JvmStatic
		val LOCATION = ResourceLocation(OverdriveThatMatters.MOD_ID, "textures/atlas/gui.png")

		@JvmStatic
		var INSTANCE: WidgetAtlasHolder by WriteOnce()
			private set

		@JvmStatic
		fun register(event: RegisterClientReloadListenersEvent) {
			INSTANCE = WidgetAtlasHolder(minecraft.textureManager)
			event.registerReloadListener(INSTANCE)
			isWidgetAtlasAvailable = true
		}
	}
}
